//////////////////////////////////////////////////////////////////////////// 
// IPD - Image Processing Design Toolbox
//
// Copyright (c) by Dr. Eng. (J) Harald Galda, 2009 - 2010
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////


// Version, presence of Atlas library and development tools are checked.

Version = getversion('scilab');

VersionError = 'This toolbox requires Scilab 5.2.0 or higher.';

if Version(1) < 5 then
  
 error(VersionError);
  
end;

if (Version(1) == 5) & (Version(2) < 2) then
  
 error(VersionError);
  
end;

if ~with_atlas() then
  
 error('This toolbox requires Atlas library. Please re-install ' + ...
       'Scilab and choose Atlas library option.');

end;

if ~with_module('development_tools') then
  
 error('This toolbox requires development tools. Please re-install ' + ...
       'with development tools.'); 

end;

// Name is set.
ToolboxName = 'IPD';

// Path is set.
ToolboxPath = get_absolute_file_path('builder.sce');

// Help, library and macros are built.

tbx_builder_macros(ToolboxPath);

tbx_builder_help(ToolboxPath);

tbx_build_loader(ToolboxName, ToolboxPath);

tbx_build_cleaner(ToolboxName, ToolboxPath);

tbx_builder_gateway(ToolboxPath);

// Variables are cleared.

clear Version;

clear VersionError;

clear ToolboxName;

clear ToolboxPath;
