//////////////////////////////////////////////////////////////////////////// 
// IPD - Image Processing Design Toolbox
//
// Copyright (c) by Dr. Eng. (J) Harald Galda, 2009 - 2010
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

DemoPath = get_absolute_file_path('BlobAnalysis.sce');

disp('RGB = ReadImage(''teaset.png'');');

disp('figure(); ShowColorImage(RGB, ''Original Image'');');

disp('Image = RGB2Gray(RGB);');

disp('figure(); OriginalFigure = ShowImage(Image, ''Intensity Image'');');

disp('Image = uint8(255 * ones(size(Image, 1), size(Image, 2))) - Image;');

disp('figure(); ShowImage(Image, ''Inverted Intensity Image'');');

RGB = ReadImage(DemoPath + 'teaset.png');

Image = RGB2Gray(RGB);

figure(); 

ShowColorImage(RGB, 'Original Image');

clear RGB;

figure(); 

OriginalFigure = ShowImage(Image, 'Intensity Image');

Image = uint8(255 * ones(size(Image, 1), size(Image, 2))) - Image;

disp('Threshold = 100; ThresholdImage = SegmentByThreshold(Image, Threshold);');

disp('figure(); ShowImage(ThresholdImage, ''Thresholded Image'');');

Threshold = 100;

ThresholdImage = SegmentByThreshold(Image, Threshold);

clear Image;

figure();

ShowImage(ThresholdImage, 'Thresholded Image');

disp('ObjectImage = SearchBlobs(ThresholdImage);');

disp('ColorMapSize = max(3, max(ObjectImage));');

disp('figure(); ShowImage(ObjectImage, ''Object Image'', ' + ...
     'jetcolormap(ColorMapSize));');

ObjectImage = SearchBlobs(ThresholdImage);

clear ThresholdImage;

ColorMapSize = max(3, max(ObjectImage));

figure();

ShowImage(ObjectImage, 'Object Image', jetcolormap(ColorMapSize));

disp('ObjectImage = FilterBySize(ObjectImage, 10000);');

disp('ColorMapSize = max(3, max(FilteredObjectImage));');

disp('figure(); ShowImage(FilteredObjectImage, ' + ...
     '''Filtered Object Image'', jetcolormap(ColorMapSize));');

ObjectImage = FilterBySize(ObjectImage, 10000);

ColorMapSize = max(3, max(ObjectImage));

figure();

ShowImage(ObjectImage, ...
          'Filtered Object Image', ...
          jetcolormap(ColorMapSize));

disp('IsCalculated = CreateFeatureStruct(); IsCalculated.BoundingBox = %t;');

IsCalculated = CreateFeatureStruct();

IsCalculated.BoundingBox = %t;

disp(IsCalculated);

disp('BlobStatistics = AnalyzeBlobs(FilteredObjectImage, IsCalculated);');

disp('DrawBoundingBoxes(BlobStatistics, [1 1 1]);');

disp('DrawBoundingBoxes(BlobStatistics, [1 0 0], OriginalFigure);');

IsCalculated = CreateFeatureStruct();

IsCalculated.BoundingBox = %t;

BlobStatistics = AnalyzeBlobs(ObjectImage, IsCalculated);

DrawBoundingBoxes(BlobStatistics, [1 1 1]);

DrawBoundingBoxes(BlobStatistics, [1 0 0], OriginalFigure);

clear ObjectImage;

clear IsCalculated;

clear BlobStatistics;
