//////////////////////////////////////////////////////////////////////////// 
// IPD - Image Processing Design Toolbox
//
// Copyright (c) by Dr. Eng. (J) Harald Galda, 2009 - 2010
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

disp('RGB = ReadImage(DemoPath + ''teaset.png'');');

disp('Gradient = EdgeFilter(Image, EDGE_SOBEL);');

disp('figure(); ShowImage(Gradient, ''Gradient Image'');');

disp('EdgeImage = ~SegmentByThreshold(Gradient, 60);');

disp('DistanceImage = DistanceTransform(EdgeImage);');

disp('ThresholdImage = SegmentByThreshold(DistanceImage, 8);');

disp('MarkerImage = uint32(SearchBlobs(ThresholdImage));');

disp('figure(); ShowImage(MarkerImage, ''Marker Image'', ' + ...
     'jetcolormap(64));');
          
disp('SegmentedImage = Watershed(Gradient, MarkerImage);');

disp('ColorMapLength = length(unique(SegmentedImage));');

disp('figure(); ShowImage(SegmentedImage, ' + ...
     '''Result of Watershed Transform'', ' + ...
     'jetcolormap(ColorMapLength));');

DemoPath = get_absolute_file_path('Watershed.sce');

RGB = ReadImage(DemoPath + 'teaset.png');

Image = RGB2Gray(RGB);

Gradient = EdgeFilter(Image, EDGE_SOBEL);

figure(); 

ShowImage(Gradient, 'Gradient Image', jetcolormap(256));

EdgeImage = ~SegmentByThreshold(Gradient, 60);

DistanceImage = DistanceTransform(EdgeImage);

ThresholdImage = SegmentByThreshold(DistanceImage, 8);
          
MarkerImage = SearchBlobs(ThresholdImage);

figure();          

ShowImage(MarkerImage, 'Marker Image', jetcolormap(64));

SegmentedImage = Watershed(Gradient, MarkerImage);

figure();

ColorMapLength = length(unique(SegmentedImage));

ShowImage(SegmentedImage, ...
          'Result of Watershed Transform', ...
          jetcolormap(ColorMapLength));                    
          
clear RGB;

clear Image;

clear Gradient;

clear EdgeImage;

clear DistanceImage;

clear ThresholdImage;

clear MarkerImage;

clear SegmentedImage;

clear ColorMapLength;
