//////////////////////////////////////////////////////////////////////////// 
// IPD - Image Processing Design Toolbox
//
// Copyright (c) by Dr. Eng. (J) Harald Galda, 2009 - 2010
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////


CPPGateWayPath = get_absolute_file_path('builder_gateway_cpp.sce');

LibraryName = 'libIPD';

FunctionMatrix = ['CloseVideoFile', 'int_CloseVideoFile'; ...
                  'ConvertColorSpace', 'int_ConvertColorSpace'; ...
                  'CreatePixelIndexList', 'int_CreatePixelIndexList'; ...
                  'DistanceTransform', 'int_DistanceTransform'; ...
                  'EdgeFilter', 'int_EdgeFilter'; ...
                  'GetVideoInfo', 'int_GetVideoInfo'; ...
                  'MedianFilter', 'int_MedianFilter'; ...
                  'MorphologicalFilter', 'int_MorphologicalFilter'; ...
                  'OpenVideoFile', 'int_OpenVideoFile'; ...
                  'ReadImageFile', 'int_ReadImageFile'; ...
                  'ReadImageFromVideo', 'int_ReadImageFromVideo'; ...
                  'SearchBlobs', 'int_SearchBlobs'; ...
                  'Watershed', 'int_Watershed'; ...
                  'WriteImageFile', 'int_WriteImageFile'];
                  
FileList = ['CloseVideoFile.cpp'; ...
            'ConvertColorSpace.cpp'; ...
            'CreatePixelIndexList.cpp'; ...
            'DistanceTransform.cpp'; ...
            'EdgeFilter.cpp'; ...
            'GetVideoInfo.cpp'; ...
            'MedianFilter.cpp'; ...
            'MorphologicalFilter.cpp'; ...
            'OpenVideoFile.cpp'; ...
            'ReadImageFile.cpp'; ...
            'ReadImageFromVideo.cpp'; ...
            'SearchBlobs.cpp'; ...
            'Watershed.cpp'; ...
            'WriteImageFile.cpp']; 
                        
ListOfLibraries = ['cxcore200', ...
                   'cv200', ...
                   'highgui200'];

IncludePath = '-I""' + CPPGateWayPath + 'include""';

if MSDOS then 
  
 LibraryPath = '-LIBPATH:""' + CPPGateWayPath + 'lib""';
 
else
  
  // To do: setting library and include path for Linux
  
end;
 
tbx_build_gateway(LibraryName, ...
                  FunctionMatrix, ...
                  FileList, ...
                  CPPGateWayPath, ...
                  ListOfLibraries, ...
                  LibraryPath, ...
                  IncludePath);
                  
if MSDOS then
  
 deletefile(CPPGateWayPath + 'loader.sce'); 
 
 copyfile(CPPGateWayPath + 'loader_for_windows.sce', ...
          CPPGateWayPath + 'loader.sce');
   
end;
                  
clear LibraryName;

clear CPPGateWayPath;
                  
clear FunctionMatrix;

clear FileList;

clear ListOfLibraries; 

clear IncludePath;


                                   